﻿Option Strict On
Option Explicit On

Imports System.IO

Public Class Form1
    Dim auftragsfile As String = "c:\users\" + Environment.UserName + "\desktop\auftragsübersicht.xml"
    Private myfont As Font = New Font("Calibri", 10, FontStyle.Regular)


    Private pagenb As Integer
    Private index As Integer
    Private indextext As Integer

    Private Y As Integer
    Private X As Integer
    Private leftMargin As Integer
    Private rightMargin As Integer
    Private topMargin As Integer
    Private bottomMargin As Integer
    Private Angebotsbreite As Integer
    Private AngebotsHeight As Integer
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Reload()
    End Sub

    Private Sub Reload()

        DtsAufträge.Clear()
        For Each tb As DataTable In DtsAufträge.Tables
            tb.BeginLoadData()
        Next
        If File.Exists(auftragsfile) Then
            DtsAufträge.ReadXml(auftragsfile)
        End If
        For Each tb As DataTable In DtsAufträge.Tables
            tb.EndLoadData()
        Next
    End Sub

    Private Sub btspeichern_Click(sender As Object, e As EventArgs) Handles btspeichern.Click
        DtsAufträge.WriteXml(auftragsfile)
    End Sub
    Public Function Ausgabenhöhe(ByVal S As SizeF, ByVal B As Double) As Double
        Dim H As Double
        If S.Width > B Then
            H = (S.Width / B)
        Else
            H = S.Height
        End If
        Return H
    End Function

    Private _sfright As New StringFormat With {.Alignment = StringAlignment.Far}

    Private Sub btdrucken_Click(sender As Object, e As EventArgs) Handles btdrucken.Click

        If DtsAufträge.Auftragsübersicht.Rows.Count > 0 Then
            Using dlg As New PrintDialog
                If dlg.ShowDialog() = DialogResult.OK Then

                    PrintDocument1.PrinterSettings = dlg.PrinterSettings
                    PrintPreviewDialog1.WindowState = FormWindowState.Maximized
                    PrintPreviewDialog1.Document = Me.PrintDocument1
                    PrintPreviewDialog1.ShowDialog()
                Else
                    MessageBox.Show("Abbruch!", "Auftragsmodul")
                    Exit Sub
                End If
            End Using
        End If
    End Sub

    Private Sub PrintDocument1_BeginPrint(sender As Object, e As Printing.PrintEventArgs) Handles PrintDocument1.BeginPrint
        Me.pagenb = 0
        Me.index = 0
        Me.indextext = 0
        FKAuftragsübersichtAuftragsdetailBindingSource.MoveFirst()
    End Sub

    Private Sub PrintDocument1_PrintPage(sender As Object, e As Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage

        Dim margin = PrintDocument1.DefaultPageSettings.Margins
        Dim g = e.Graphics
        Dim brush As New SolidBrush(Color.LightGray)
        Dim brush1 As New SolidBrush(Color.Black)
        Dim pen1 As New Pen(Brushes.LightGray, 0.5)
        Dim pen2 As New Pen(Brushes.DarkGray, 0.5)
        Dim pen3 As New Pen(Brushes.White, 0.5)
        Dim LineHeight As Single = Me.myfont.GetHeight

        margin.Left = 30
        margin.Right = 30
        margin.Top = 30
        margin.Bottom = 30

        leftMargin = margin.Left
        rightMargin = margin.Right
        topMargin = margin.Top
        bottomMargin = margin.Bottom

        Dim rc = e.Graphics.VisibleClipBounds
        rc.Offset(margin.Left + 30, margin.Top + 30)        ' obere linke Ecke
        rc.Width -= (margin.Left + 20 + margin.Right - 20)  ' neue Breite
        rc.Height -= (margin.Top + margin.Bottom) ' neue Höhe

        X = leftMargin
        Y = topMargin

        Dim strformat As New StringFormat(StringFormatFlags.LineLimit)
        Dim charactersfitted As Integer
        Dim linesfilled As Integer

        If pagenb = 0 Then

            Y += 240

            g.DrawString("Auftragsnummer" & vbTab & vbTab & ":", myfont, Brushes.Black, X + 10, Y)

            Y += 20
            g.DrawString("Bauvorhaben" & vbTab & vbTab & ":", myfont, Brushes.Black, X + 10, Y)

            Y += 50

            Y += 50

            g.FillRectangle(brush, X + 10, Y, 40, 30)
            g.DrawString("Pos.", myfont, Brushes.Black, X + 15, Y + 5)
            g.FillRectangle(brush, X + 52, Y, 400, 30)
            g.DrawString("Leistung", myfont, Brushes.Black, X + 240, Y + 5)
            g.FillRectangle(brush, X + 454, Y, 65, 30)
            g.DrawString("Menge", myfont, Brushes.Black, X + 462, Y + 5)
            g.FillRectangle(brush, X + 521, Y, 55, 30)
            g.DrawString("Einheit", myfont, Brushes.Black, X + 524, Y + 5)
            g.FillRectangle(brush, X + 578, Y, 80, 30)
            g.DrawString("EP [€]", myfont, Brushes.Black, X + 600, Y + 5)
            g.FillRectangle(brush, X + 660, Y, 80, 30)
            g.DrawString("GP [€]", myfont, Brushes.Black, X + 685, Y + 5)

            For i = index To FKAuftragsübersichtAuftragsdetailBindingSource.Count - 1

                Dim row1 = DirectCast(DirectCast(FKAuftragsübersichtAuftragsdetailBindingSource.Current, DataRowView).Row, DtsAufträge.AuftragsdetailRow)
                Dim an = g.VisibleClipBounds
                an.Offset(X + 60, Y + 35)
                an.Width = 380
                an.Height = Y + (charactersfitted * linesfilled)

                Dim S As SizeF
                Dim Hoch As Double
                Dim B = 380

                indextext = 0
                S = g.MeasureString(row1.Leistung.Substring(indextext), myfont, an.Size, strformat, charactersfitted, linesfilled)
                Hoch = Ausgabenhöhe(S, B)

                If Y + (linesfilled * myfont.GetHeight) > 850 Then

                    g.DrawString(String.Format(" - Seite {0} -", pagenb + 1), myfont, brush, 380, 1130)
                    e.HasMorePages = True
                    pagenb += 1
                    Exit Sub
                Else
                    If Not row1.IsLeistungNull Then
                        g.DrawString(row1.Leistung.Substring(indextext), myfont, Brushes.Black, an, strformat)
                    End If
                End If

                If Not row1.IsPosNull Then
                    g.DrawString(CStr(row1.Pos), myfont, Brushes.Black, X + 17, Y + 35)
                End If

                Dim drawrect As New RectangleF(X + 60, Y + 35, B, CInt(Hoch))
                g.DrawRectangle(pen3, X + 58, Y + 33, CInt(B + 4), CInt(Hoch + 2))

                If Not row1.IsMengeNull Then
                    g.DrawString(Format(row1.Menge, "N2"), myfont, Brushes.Black, X + 460, Y + 35)
                End If
                If Not row1.IsEinheitNull Then
                    g.DrawString(Format(row1.Einheit), myfont, Brushes.Black, X + 530, Y + 35)
                End If
                If Not row1.IsEinzelpreisNull Then
                    g.DrawString(Format(row1.Einzelpreis, "C2"), myfont, Brushes.Black, X + 598, Y + 35)
                End If
                If Not row1.IsGesamtpreisNull Then
                    g.DrawString(Format(row1.Gesamtpreis, "C2"), myfont, Brushes.Black, X + 663, Y + 35)
                End If


                If Hoch > 20 Then
                    Y += 35
                    g.DrawLine(pen1, X + 51, Y, X + 51, Y + CInt(Hoch + 7))
                    g.DrawLine(pen1, X + 453, Y, X + 453, Y + CInt(Hoch + 7))
                    g.DrawLine(pen1, X + 520, Y, X + 520, Y + CInt(Hoch + 7))
                    g.DrawLine(pen1, X + 577, Y, X + 577, Y + CInt(Hoch + 7))
                    g.DrawLine(pen1, X + 659, Y, X + 659, Y + CInt(Hoch + 7))
                    g.DrawLine(pen1, X + 10, Y + CInt(Hoch + 7), X + 739, Y + CInt(Hoch + 7))
                    Y += CInt(Hoch) - 20
                End If
                If Hoch < 20 Then
                    Y += 35
                    g.DrawLine(pen1, X + 51, Y, X + 51, Y + 25)
                    g.DrawLine(pen1, X + 453, Y, X + 453, Y + 25)
                    g.DrawLine(pen1, X + 520, Y, X + 520, Y + 25)
                    g.DrawLine(pen1, X + 577, Y, X + 577, Y + 25)
                    g.DrawLine(pen1, X + 659, Y, X + 659, Y + 25)
                    g.DrawLine(pen1, X + 10, Y + 25, X + 739, Y + 25)
                End If

                index += 1
                indextext += charactersfitted
                FKAuftragsübersichtAuftragsdetailBindingSource.MoveNext()

                If Y >= 850 Then
                    g.DrawString(String.Format(" - Seite {0} -", pagenb + 1), myfont, brush, 380, 1130)
                    e.HasMorePages = True
                    pagenb += 1
                    Exit Sub
                End If
            Next

            If Y >= 850 Then
                g.DrawString(String.Format(" - Seite {0} -", pagenb + 1), myfont, brush, 380, 1130)
                e.HasMorePages = True
                pagenb += 1
                Exit Sub
            Else
                Dim rectnetto = New RectangleF(X + 655, Y + 50, 85, Height)
                Dim rectmwst = New RectangleF(X + 655, Y + 72, 85, Height)
                Dim rectskonto = New RectangleF(X + 655, Y + 92, 85, Height)
                Dim rectbrutto = New RectangleF(X + 655, Y + 112, 85, Height)

                g.DrawString(String.Format(" - Seite {0} -", pagenb + 1), myfont, brush, 380, 1130)
                e.HasMorePages = False
            End If
        End If

        Y += 80

        If pagenb >= 1 Then
            X = leftMargin
            Y = topMargin
            Y += 30

            indextext = charactersfitted

            If index = FKAuftragsübersichtAuftragsdetailBindingSource.Count Then

            Else
                g.FillRectangle(brush, X + 10, Y, 40, 30)
                g.DrawString("Pos.", myfont, Brushes.Black, X + 15, Y + 5)
                g.FillRectangle(brush, X + 51, Y, 400, 30)
                g.DrawString("Leistung", myfont, Brushes.Black, X + 240, Y + 5)
                g.FillRectangle(brush, X + 453, Y, 65, 30)
                g.DrawString("Menge", myfont, Brushes.Black, X + 462, Y + 5)
                g.FillRectangle(brush, X + 519, Y, 60, 30)
                g.DrawString("Einheit", myfont, Brushes.Black, X + 528, Y + 5)
                g.FillRectangle(brush, X + 580, Y, 80, 30)
                g.DrawString("EP [€]", myfont, Brushes.Black, X + 600, Y + 5)
                g.FillRectangle(brush, X + 661, Y, 80, 30)
                g.DrawString("GP [€]", myfont, Brushes.Black, X + 685, Y + 5)
            End If

            For i = index To FKAuftragsübersichtAuftragsdetailBindingSource.Count - 1

                Dim row1 = DirectCast(DirectCast(FKAuftragsübersichtAuftragsdetailBindingSource.Current, DataRowView).Row, DtsAufträge.AuftragsdetailRow)
                Dim S As SizeF
                Dim Hoch As Double
                Dim B = 380
                Dim drawrect As New RectangleF(X + 60, Y + 35, B, CSng(Hoch))
                Dim an = g.VisibleClipBounds
                an.Offset(X + 60, Y + 35)
                S = g.MeasureString(row1.Leistung, myfont, B)
                Hoch = Ausgabenhöhe(S, B)

                an.Width = 380
                an.Height = CInt(Hoch)

                If Y >= 850 Then
                    g.DrawString(String.Format(" - Seite {0} -", pagenb + 1), myfont, brush, 380, 1130)
                    e.HasMorePages = True
                    pagenb += 1
                    Exit Sub
                Else
                    If Not row1.IsLeistungNull Then
                        g.DrawString(row1.Leistung.Substring(indextext), myfont, Brushes.Black, an, strformat)
                    End If
                End If

                If Not row1.IsPosNull Then
                    g.DrawString(CStr(row1.Pos), myfont, Brushes.Black, X + 17, Y + 35)
                End If

                g.DrawRectangle(pen3, X + 58, Y + 33, CInt(B + 4), CInt(Hoch + 2))

                If Not row1.IsMengeNull Then
                    g.DrawString(Format(row1.Menge, "N2"), myfont, Brushes.Black, X + 465, Y + 35)
                End If
                If Not row1.IsEinheitNull Then
                    g.DrawString(Format(row1.Einheit), myfont, Brushes.Black, X + 535, Y + 35)
                End If
                If Not row1.IsEinzelpreisNull Then
                    g.DrawString(Format(row1.Einzelpreis, "C2"), myfont, Brushes.Black, X + 603, Y + 35)
                End If
                If Not row1.IsGesamtpreisNull Then
                    g.DrawString(Format(row1.Gesamtpreis, "C2"), myfont, Brushes.Black, X + 668, Y + 35)
                End If

                If Hoch > 20 Then
                    Y += 35
                    g.DrawLine(pen1, X + 51, Y, X + 51, Y + CInt((Hoch + 7)))
                    g.DrawLine(pen1, X + 453, Y, X + 453, Y + CInt((Hoch + 7)))
                    g.DrawLine(pen1, X + 520, Y, X + 520, Y + CInt((Hoch + 7)))
                    g.DrawLine(pen1, X + 582, Y, X + 582, Y + CInt((Hoch + 7)))
                    g.DrawLine(pen1, X + 664, Y, X + 664, Y + CInt((Hoch + 7)))
                    g.DrawLine(pen1, X + 10, Y + CInt(Hoch + 7), X + 739, Y + CInt(Hoch + 7))
                    Y += CInt(Hoch) - 20
                End If
                If Hoch < 20 Then
                    Y += 35
                    g.DrawLine(pen1, X + 51, Y, X + 51, Y + 25)
                    g.DrawLine(pen1, X + 453, Y, X + 453, Y + 25)
                    g.DrawLine(pen1, X + 520, Y, X + 520, Y + 25)
                    g.DrawLine(pen1, X + 582, Y, X + 582, Y + 25)
                    g.DrawLine(pen1, X + 664, Y, X + 664, Y + 25)
                    g.DrawLine(pen1, X + 10, Y + 25, X + 739, Y + 25)
                End If

                index = i + 1
                FKAuftragsübersichtAuftragsdetailBindingSource.MoveNext()

                If Y >= 850 Or indextext < charactersfitted Then
                    g.DrawString(String.Format(" - Seite {0} -", pagenb + 1), myfont, brush, 380, 1130)
                    e.HasMorePages = True
                    pagenb += 1
                    Exit Sub
                End If
            Next

            Y += 30

            If Y >= 850 Then
                g.DrawString(String.Format(" - Seite {0} -", pagenb + 1), myfont, brush, 380, 1130)
                e.HasMorePages = True
                pagenb += 1
                Exit Sub
            Else
                Dim rectnetto = New RectangleF(X + 655, Y + 50, 85, Height)
                Dim rectmwst = New RectangleF(X + 655, Y + 72, 85, Height)
                Dim rectskonto = New RectangleF(X + 655, Y + 92, 85, Height)
                Dim rectbrutto = New RectangleF(X + 655, Y + 112, 85, Height)


                g.DrawString(String.Format(" - Seite {0} -", pagenb + 1), myfont, brush, 380, 1130)
                e.HasMorePages = False
            End If
        End If

    End Sub
End Class
